#include "gs.h"
#include <graph.h>
#include <dma.h>

int gs_init(struct draw_state *ds, int psm, int psmz) {
    ds->fb.address = graph_vram_allocate(ds->width, ds->height, psm, GRAPH_ALIGN_PAGE);
    ds->fb.width = ds->width;
    ds->fb.height = ds->height;
    ds->fb.psm = psm;
    ds->fb.mask = 0;
    ds->zb.address = graph_vram_allocate(ds->width, ds->height, psmz, GRAPH_ALIGN_PAGE);
    ds->zb.enable = 0;
    ds->zb.method = 0;
    ds->zb.zsm = 0;
    ds->zb.mask = 0;
    graph_set_mode(ds->gmode, ds->vmode, GRAPH_MODE_FIELD, GRAPH_DISABLE);
    graph_set_screen(0, 0, ds->width, ds->height);
    graph_set_bgcolor(0, 0, 0);
    graph_set_framebuffer_filtered(ds->fb.address, ds->width, psm, 0, 0);
    graph_enable_output();
    qword_t buf[100];
    qword_t *q = buf;
    q = draw_setup_environment(q, 0, &ds->fb, &ds->zb);
    q = draw_primitive_xyoffset(q, 0, 2048-(ds->width/2), 2048-(ds->height/2));
    q = draw_finish(q);
    dma_channel_send_normal(DMA_CHANNEL_GIF, buf, q-buf, 0, 0);
    dma_wait_fast();
    return 0;
}